Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 2819)
@@ -17,10 +17,9 @@
    !!   p4z_lys_init   :   Read the namelist parameters
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc
-   USE sms_pisces
-   USE prtctl_trc
-   USE iom
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
 
    IMPLICIT NONE
@@ -62,10 +61,8 @@
       INTEGER, INTENT(in) ::   kt ! ocean time step
       INTEGER  ::   ji, jj, jk, jn
-      REAL(wp) ::   zbot, zalk, zdic, zph, zremco3, zah2
+      REAL(wp) ::   zbot, zalk, zdic, zph, zah2
       REAL(wp) ::   zdispot, zfact, zalka
       REAL(wp) ::   zomegaca, zexcess, zexcess0
-#if defined key_diatrc && defined key_iomput
       REAL(wp) ::   zrfact2
-#endif
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -75,8 +72,6 @@
       END IF
 
-      zco3(:,:,:) = 0.
-# if defined key_diatrc && defined key_iomput
+      zco3    (:,:,:) = 0.
       zcaldiss(:,:,:) = 0.
-# endif
       !     -------------------------------------------
       !     COMPUTE [CO3--] and [H+] CONCENTRATIONS
@@ -91,23 +86,15 @@
 !CDIR NOVERRCHK
                DO ji = 1, jpi
-
                   ! SET DUMMY VARIABLE FOR TOTAL BORATE
-                  zbot  = borat(ji,jj,jk)
-
-                  ! SET DUMMY VARIABLE FOR TOTAL BORATE
-                  zbot  = borat(ji,jj,jk)
+                  zbot  = borat(ji,jj,jk)    
                   zfact = rhop (ji,jj,jk) / 1000. + rtrn
-
                   ! SET DUMMY VARIABLE FOR [H+]
                   zph   = hi(ji,jj,jk) * tmask(ji,jj,jk) / zfact + ( 1.-tmask(ji,jj,jk) ) * 1.e-9
-
                   ! SET DUMMY VARIABLE FOR [SUM(CO2)]GIVEN 
                   zdic  = trn(ji,jj,jk,jpdic) / zfact
                   zalka = trn(ji,jj,jk,jptal) / zfact
-
                   ! CALCULATE [ALK]([CO3--], [HCO3-])
                   zalk  = zalka - (  akw3(ji,jj,jk) / zph - zph   &
                      &             + zbot / (1.+ zph / akb3(ji,jj,jk) )  )
-
                   ! CALCULATE [H+] and [CO3--]
                   zah2 = SQRT( (zdic-zalk)*(zdic-zalk)+   &
@@ -146,38 +133,32 @@
                !       (ACCORDING TO THIS FORMULATION ALSO SOME PARTICULATE
                !       CACO3 GETS DISSOLVED EVEN IN THE CASE OF OVERSATURATION)
+               zdispot = kdca * zexcess * trn(ji,jj,jk,jpcal)
 # if defined key_degrad
-              zdispot = kdca * zexcess * trn(ji,jj,jk,jpcal) * facvol(ji,jj,jk)
-# else
-              zdispot = kdca * zexcess * trn(ji,jj,jk,jpcal)
+               zdispot = zdispot * facvol(ji,jj,jk)
 # endif
-
               !  CHANGE OF [CO3--] , [ALK], PARTICULATE [CACO3],
               !       AND [SUM(CO2)] DUE TO CACO3 DISSOLUTION/PRECIPITATION
-              zremco3 = zdispot / rmtss
-              zco3(ji,jj,jk) = zco3(ji,jj,jk) + zremco3 * rfact
-              tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) + 2. * zremco3
-              tra(ji,jj,jk,jpcal) = tra(ji,jj,jk,jpcal) -      zremco3
-              tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) +      zremco3
-
-# if defined key_diatrc && defined key_iomput
-              zcaldiss(ji,jj,jk) = zremco3  ! calcite dissolution
-# endif
+              zcaldiss(ji,jj,jk)  = zdispot / rmtss  ! calcite dissolution
+              zco3(ji,jj,jk)      = zco3(ji,jj,jk) + zcaldiss(ji,jj,jk) * rfact
+              !
+              tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) + 2. * zcaldiss(ji,jj,jk)
+              tra(ji,jj,jk,jpcal) = tra(ji,jj,jk,jpcal) -      zcaldiss(ji,jj,jk)
+              tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) +      zcaldiss(ji,jj,jk)
             END DO
          END DO
       END DO
 
-# if defined key_diatrc
-#  if ! defined key_iomput
-      trc3d(:,:,:,jp_pcs0_3d    ) = hi  (:,:,:)          * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 1) = zco3(:,:,:)          * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 2) = aksp(:,:,:) / calcon * tmask(:,:,:)
-#  else
-      zrfact2 = 1.e3 * rfact2r
-      CALL iom_put( "PH"    , hi      (:,:,:)           * tmask(:,:,:) )
-      CALL iom_put( "CO3"   , zco3    (:,:,:)           * tmask(:,:,:) )
-      CALL iom_put( "CO3sat", aksp    (:,:,:) / calcon  * tmask(:,:,:) )
-      CALL iom_put( "DCAL"  , zcaldiss(:,:,:) * zrfact2 * tmask(:,:,:) )
-#  endif
+      IF( ln_diatrc )  THEN
+         zrfact2 = 1.e3 * rfact2r
+         CALL iom_put( "PH"    , hi      (:,:,:)           * tmask(:,:,:) )
+         CALL iom_put( "CO3"   , zco3    (:,:,:)           * tmask(:,:,:) )
+         CALL iom_put( "CO3sat", aksp    (:,:,:) / calcon  * tmask(:,:,:) )
+         CALL iom_put( "DCAL"  , zcaldiss(:,:,:) * zrfact2 * tmask(:,:,:) )
+# if ! defined key_iomput
+         trc3d(:,:,:,jp_pcs0_3d    ) = hi  (:,:,:)          * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 1) = zco3(:,:,:)          * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 2) = aksp(:,:,:) / calcon * tmask(:,:,:)
 # endif
+      ENDIF
       !
        IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -207,6 +188,6 @@
       NAMELIST/nampiscal/ kdca, nca
 
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampiscal )
+      REWIND( numnatp )                     ! read numnatp
+      READ  ( numnatp, nampiscal )
 
       IF(lwp) THEN                         ! control print
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmeso.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmeso.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmeso.F90	(revision 2819)
@@ -14,12 +14,11 @@
    !!   p4z_meso_init  :   Initialization of the parameters for mesozooplankton
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc         ! 
-   USE sms_pisces      ! 
-   USE prtctl_trc
-   USE p4zint
-   USE p4zsink
-   USE iom
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
+
 
    IMPLICIT NONE
@@ -75,7 +74,5 @@
       REAL(wp) :: zgrazfff,zgrazffe
       CHARACTER (len=25) :: charout
-#if defined key_diatrc && defined key_iomput
       REAL(wp) :: zrfact2
-#endif
 
       !!---------------------------------------------------------------------
@@ -84,12 +81,10 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-
                zcompam = MAX( ( trn(ji,jj,jk,jpmes) - 1.e-9 ), 0.e0 )
+               zstep   = xstep
 # if defined key_degrad
-               zstep   = xstep * facvol(ji,jj,jk)
-# else
-               zstep   = xstep
-# endif
-               zfact   = zstep * tgfunc(ji,jj,jk) * zcompam
+               zstep = zstep * facvol(ji,jj,jk)
+# endif
+               zfact = zstep * tgfunc(ji,jj,jk) * zcompam
 
                !  Respiration rates of both zooplankton
@@ -132,4 +127,7 @@
                zgrazffe = grazflux * zstep * wsbio4(ji,jj,jk)          &
                   &                 * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jpgoc) * trn(ji,jj,jk,jpmes)
+# if defined key_degrad
+               zgrazffe = zgrazffe  * facvol(ji,jj,jk)
+# endif
                zgrazfff = zgrazffe * trn(ji,jj,jk,jpbfe) / (trn(ji,jj,jk,jpgoc) + rtrn)
 # else
@@ -143,13 +141,14 @@
                !!--------------------------- KRIEST3 -------------------------------------------
 
-              zgrazffe = grazflux * zstep * wsbio3(ji,jj,jk)     &
+               zgrazffe = grazflux * zstep * wsbio3(ji,jj,jk)     &
                   &                * tgfunc2(ji,jj,jk) * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpmes)
-              zgrazfff = zgrazffe * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
+# if defined key_degrad
+               zgrazffe = zgrazffe  * facvol(ji,jj,jk)
+# endif
+               zgrazfff = zgrazffe * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
 # endif
       
-#if defined key_diatrc
-              ! Total grazing ( grazing by microzoo is already computed in p4zmicro ) 
+              ! Total grazing ( grazing by microzoo is already computed in p4zmicro )
               grazing(ji,jj,jk) = grazing(ji,jj,jk) + (  zgrazd + zgrazz + zgrazn + zgrazpoc + zgrazffe )
-#endif
 
               !    Mesozooplankton efficiency
@@ -200,7 +199,7 @@
 
                zprcaca = xfracal(ji,jj,jk) * unass2 * zgrazn
-#if defined key_diatrc
+               ! calcite production
                prodcal(ji,jj,jk) = prodcal(ji,jj,jk) + zprcaca  ! prodcal=prodcal(nanophy)+prodcal(microzoo)+prodcal(mesozoo)
-#endif
+               !
                zprcaca = part * zprcaca
                tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) - zprcaca
@@ -226,15 +225,13 @@
       END DO
       !
-#if defined key_diatrc && defined key_iomput
-      zrfact2 = 1.e3 * rfact2r
-      ! Total grazing of phyto by zoo
-      grazing(:,:,:) = grazing(:,:,:) * zrfact2 * tmask(:,:,:)
-      ! Calcite production
-      prodcal(:,:,:) = prodcal(:,:,:) * zrfact2 * tmask(:,:,:)
-      IF( jnt == nrdttrc ) then 
-         CALL iom_put( "GRAZ" , grazing  )  ! Total grazing of phyto by zooplankton
-         CALL iom_put( "PCAL" , prodcal  )  ! Calcite production
+      IF( ln_diatrc ) THEN
+         zrfact2 = 1.e3 * rfact2r
+         grazing(:,:,:) = grazing(:,:,:) * zrfact2 * tmask(:,:,:)   ! Total grazing of phyto by zoo
+         prodcal(:,:,:) = prodcal(:,:,:) * zrfact2 * tmask(:,:,:)   ! Calcite production
+         IF( jnt == nrdttrc ) THEN
+            CALL iom_put( "GRAZ" , grazing  )  ! Total grazing of phyto by zooplankton
+            CALL iom_put( "PCAL" , prodcal  )  ! Calcite production
+         ENDIF
       ENDIF
-#endif
 
        IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -263,6 +260,6 @@
          &             xprefz, xprefpoc, xkgraz2, epsher2, sigma2, unass2, grazflux
 
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampismes )
+      REWIND( numnatp )                     ! read numnatp
+      READ  ( numnatp, nampismes )
 
 
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmicro.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmicro.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmicro.F90	(revision 2819)
@@ -14,12 +14,9 @@
    !!   p4z_micro_init  :   Initialize and read the appropriate namelist
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc         ! 
-   USE sms_pisces      ! 
-   USE prtctl_trc
-   USE p4zint
-   USE p4zsink
-   USE iom
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE prtctl_trc      !  print control for debugging
 
    IMPLICIT NONE
@@ -28,4 +25,5 @@
    PUBLIC   p4z_micro         ! called in p4zbio.F90
    PUBLIC   p4z_micro_init    ! called in trcsms_pisces.F90
+   PUBLIC   p4z_micro_alloc    ! called in trcsms_pisces.F90
 
    !! * Shared module variables
@@ -74,9 +72,5 @@
       !!---------------------------------------------------------------------
 
-
-#if defined key_diatrc
-      grazing(:,:,:) = 0.  !: Initialisation of  grazing
-#endif
-
+      grazing(:,:,:) = 0.  !: grazing set to zero
       zstep = rfact2 / rday      ! Time step duration for biology
 
@@ -85,8 +79,7 @@
             DO ji = 1, jpi
                zcompaz = MAX( ( trn(ji,jj,jk,jpzoo) - 1.e-9 ), 0.e0 )
+               zstep   = xstep
 # if defined key_degrad
-               zstep   = xstep * facvol(ji,jj,jk)
-# else
-               zstep   = xstep
+               zstep = zstep * facvol(ji,jj,jk)
 # endif
                zfact   = zstep * tgfunc(ji,jj,jk) * zcompaz
@@ -126,8 +119,7 @@
                zgrazmf = zgrazm  * trn(ji,jj,jk,jpsfe) / (trn(ji,jj,jk,jppoc) + rtrn)
                zgrazsf = zgrazsd * trn(ji,jj,jk,jpdfe) / (trn(ji,jj,jk,jpdia) + rtrn)
-#if defined key_diatrc
+
                ! Grazing by microzooplankton
-               grazing(ji,jj,jk) = grazing(ji,jj,jk) + zgrazp + zgrazm + zgrazsd 
-#endif
+               grazing(ji,jj,jk) = grazing(ji,jj,jk) + zgrazp + zgrazm + zgrazsd
 
                !    Various remineralization and excretion terms
@@ -172,7 +164,7 @@
                tra(ji,jj,jk,jpsfe) = tra(ji,jj,jk,jpsfe) + ferat3 * zmortz + unass * ( zgrazpf + zgrazsf ) - (1.-unass) * zgrazmf
                zprcaca = xfracal(ji,jj,jk) * unass * zgrazp
-#if defined key_diatrc
+               !
                prodcal(ji,jj,jk) = prodcal(ji,jj,jk) + zprcaca  ! prodcal=prodcal(nanophy)+prodcal(microzoo)+prodcal(mesozoo)
-#endif
+               !
                zprcaca = part * zprcaca
                tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) - zprcaca
@@ -212,6 +204,6 @@
          &             xpref2d, xkgraz, epsher, sigma1, unass
 
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampiszoo )
+      REWIND( numnatp )                     ! read numnatp
+      READ  ( numnatp, nampiszoo )
 
       IF(lwp) THEN                         ! control print
@@ -233,4 +225,13 @@
    END SUBROUTINE p4z_micro_init
 
+   INTEGER FUNCTION p4z_micro_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_micro_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( grazing(jpi,jpj,jpk), STAT=p4z_micro_alloc )
+      IF( p4z_micro_alloc /= 0 ) CALL ctl_warn('p4z_micro_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_micro_alloc
+
 #else
    !!======================================================================
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmort.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmort.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zmort.F90	(revision 2819)
@@ -14,10 +14,9 @@
    !!   p4z_mort_init  :   Initialize the mortality params for phytoplankton
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE trc         ! 
-   USE sms_pisces      ! 
-   USE p4zsink
-   USE prtctl_trc
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE prtctl_trc      !  print control for debugging
 
    IMPLICIT NONE
@@ -26,5 +25,5 @@
    PUBLIC   p4z_mort    
    PUBLIC   p4z_mort_init    
-
+   PUBLIC   p4z_mort_alloc    
 
    !! * Shared module variables
@@ -81,19 +80,12 @@
       !!---------------------------------------------------------------------
 
-
-#if defined key_diatrc
-     prodcal(:,:,:) = 0.  !: Initialisation of calcite production variable
-#endif
-
+      prodcal(:,:,:) = 0.  !: calcite production variable set to zero
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
-
                zcompaph = MAX( ( trn(ji,jj,jk,jpphy) - 1e-8 ), 0.e0 )
-
+               zstep   = xstep
 # if defined key_degrad
-               zstep =  xstep * facvol(ji,jj,jk)  
-# else
-               zstep =  xstep  
+               zstep = zstep * facvol(ji,jj,jk)
 # endif
                !     Squared mortality of Phyto similar to a sedimentation term during
@@ -117,7 +109,8 @@
                tra(ji,jj,jk,jpnfe) = tra(ji,jj,jk,jpnfe) - zmortp * zfactfe
                zprcaca = xfracal(ji,jj,jk) * zmortp
-#if defined key_diatrc
+
+               ! calcite production
                prodcal(ji,jj,jk) = prodcal(ji,jj,jk) + zprcaca  ! prodcal=prodcal(nanophy)+prodcal(microzoo)+prodcal(mesozoo)
-#endif
+               !
                zfracal = 0.5 * xfracal(ji,jj,jk)
                tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) - zprcaca
@@ -177,9 +170,7 @@
                !    sticky and coagulate to sink quickly out of the euphotic zone
                !     ------------------------------------------------------------
-
+               zstep   = xstep
 # if defined key_degrad
-               zstep =  xstep * facvol(ji,jj,jk)  
-# else
-               zstep =  xstep  
+               zstep = zstep * facvol(ji,jj,jk)
 # endif
                !  Phytoplankton respiration 
@@ -243,6 +234,6 @@
       NAMELIST/nampismort/ wchl, wchld, mprat, mprat2, mpratm
 
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampismort )
+      REWIND( numnatp )                     ! read numnatp
+      READ  ( numnatp, nampismort )
 
       IF(lwp) THEN                         ! control print
@@ -259,4 +250,13 @@
    END SUBROUTINE p4z_mort_init
 
+   INTEGER FUNCTION p4z_mort_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_mort_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( prodcal(jpi,jpj,jpk), STAT=p4z_mort_alloc )
+      IF( p4z_mort_alloc /= 0 ) CALL ctl_warn('p4z_mort_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_mort_alloc
+
 #else
    !!======================================================================
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zopt.F90	(revision 2819)
@@ -215,17 +215,17 @@
       END DO
 
-#if defined key_diatrc
-# if ! defined key_iomput
-      ! save for outputs
-      trc2d(:,:,  jp_pcs0_2d + 10) = heup(:,:  ) * tmask(:,:,1)  
-      trc3d(:,:,:,jp_pcs0_3d + 3)  = etot(:,:,:) * tmask(:,:,:)
-# else
-      ! write diagnostics 
-      IF( jnt == nrdttrc ) then 
-         CALL iom_put( "Heup", heup(:,:  ) * tmask(:,:,1) )  ! euphotic layer deptht
-         CALL iom_put( "PAR" , etot(:,:,:) * tmask(:,:,:) )  ! Photosynthetically Available Radiation
+      IF( ln_diatrc ) THEN        ! save output diagnostics
+        !
+        IF( lk_iomput ) THEN
+           IF( jnt == nrdttrc ) THEN
+              CALL iom_put( "Heup", heup(:,:  ) * tmask(:,:,1) )  ! euphotic layer deptht
+              CALL iom_put( "PAR" , etot(:,:,:) * tmask(:,:,:) )  ! Photosynthetically Available Radiation
+           ENDIF
+        ELSE
+           trc2d(:,:,  jp_pcs0_2d + 10) = heup(:,:  ) * tmask(:,:,1)  
+           trc3d(:,:,:,jp_pcs0_3d + 3)  = etot(:,:,:) * tmask(:,:,:)
+        ENDIF
+        !
       ENDIF
-# endif
-#endif
       !
       IF(  wrk_not_released(2, 1,2)           .OR.   &
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zprod.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 2819)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                         ***  MODULE p4zprod  ***
-   !! TOP :   PISCES 
+   !! TOP :  Growth Rate of the two phytoplanktons groups 
    !!======================================================================
    !! History :   1.0  !  2004     (O. Aumont) Original code
@@ -11,14 +11,15 @@
    !!   'key_pisces'                                       PISCES bio-model
    !!----------------------------------------------------------------------
-   !!   p4z_prod       :  
-   !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE sms_pisces      ! 
-   USE prtctl_trc
-   USE p4zopt
-   USE p4zint
-   USE p4zlim
-   USE iom
+   !!   p4z_prod       :   Compute the growth Rate of the two phytoplanktons groups
+   !!   p4z_prod_init  :   Initialization of the parameters for growth
+   !!   p4z_prod_alloc :   Allocate variables for growth
+   !!----------------------------------------------------------------------
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zopt          !  optical model
+   USE p4zlim          !  Co-limitations of differents nutrients
+   USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
 
    IMPLICIT NONE
@@ -84,7 +85,5 @@
       REAL(wp) ::   zpislopen  , zpislope2n
       REAL(wp) ::   zrum, zcodel, zargu, zval, zvol
-#if defined key_diatrc
       REAL(wp) ::   zrfact2
-#endif
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -108,9 +107,6 @@
 
       ! Computation of the optimal production
-# if defined key_degrad
-      prmax(:,:,:) = rday1 * tgfunc(:,:,:) * facvol(:,:,:)
-# else
-      prmax(:,:,:) = rday1 * tgfunc(:,:,:)
-# endif
+      prmax(:,:,:) = rday1 * tgfunc(:,:,:) 
+      IF( lk_degrad )  prmax(:,:,:) = prmax(:,:,:) * facvol(:,:,:) 
 
       ! compute the day length depending on latitude and the day
@@ -321,11 +317,11 @@
      ! Total primary production per year
 
-#if defined key_degrad
-     tpp = tpp + glob_sum( ( zprorca(:,:,:) + zprorcad(:,:,:) ) * cvol(:,:,:) * facvol(:,:,:) )
-#else
-     tpp = tpp + glob_sum( ( zprorca(:,:,:) + zprorcad(:,:,:) ) * cvol(:,:,:) )
-#endif
-
-     IF( kt == nitend .AND. jnt == nrdttrc .AND. lwp ) THEN
+     IF( lk_degrad )  THEN
+        tpp = tpp + glob_sum( ( zprorca(:,:,:) + zprorcad(:,:,:) ) * cvol(:,:,:) * facvol(:,:,:) )
+     ELSE
+        tpp = tpp + glob_sum( ( zprorca(:,:,:) + zprorcad(:,:,:) ) * cvol(:,:,:) )
+     ENDIF
+
+     IF( kt == nitend .AND. jnt == nrdttrc ) THEN
         WRITE(numout,*) 'Total PP (Gtc) :'
         WRITE(numout,*) '-------------------- : ',tpp * 12. / 1.E12
@@ -333,30 +329,29 @@
       ENDIF
 
-#if defined key_diatrc && ! defined key_iomput
-      !   Supplementary diagnostics
-      zrfact2 = 1.e3 * rfact2r
-      trc3d(:,:,:,jp_pcs0_3d + 4)  = zprorca (:,:,:) * zrfact2 * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 5)  = zprorcad(:,:,:) * zrfact2 * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 6)  = zpronew (:,:,:) * zrfact2 * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 7)  = zpronewd(:,:,:) * zrfact2 * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 8)  = zprorcad(:,:,:) * zrfact2 * tmask(:,:,:) * zysopt(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 9)  = zprofed (:,:,:) * zrfact2 * tmask(:,:,:)
+      IF( ln_diatrc ) THEN
+         !
+         zrfact2 = 1.e3 * rfact2r
+         IF( jnt == nrdttrc ) THEN
+            CALL iom_put( "PPPHY" , zprorca (:,:,:) * zrfact2 * tmask(:,:,:) )  ! primary production by nanophyto
+            CALL iom_put( "PPPHY2", zprorcad(:,:,:) * zrfact2 * tmask(:,:,:) )  ! primary production by diatom
+            CALL iom_put( "PPNEWN", zpronew (:,:,:) * zrfact2 * tmask(:,:,:) )  ! new primary production by nanophyto
+            CALL iom_put( "PPNEWD", zpronewd(:,:,:) * zrfact2 * tmask(:,:,:) )  ! new primary production by diatom
+            CALL iom_put( "PBSi"  , zprorcad(:,:,:) * zrfact2 * tmask(:,:,:) * zysopt(:,:,:) ) ! biogenic silica production
+            CALL iom_put( "PFeD"  , zprofed (:,:,:) * zrfact2 * tmask(:,:,:) )  ! biogenic iron production by diatom
+            CALL iom_put( "PFeN"  , zprofen (:,:,:) * zrfact2 * tmask(:,:,:) )  ! biogenic iron production by nanophyto
+         ENDIF
+#if ! defined key_iomput
+         trc3d(:,:,:,jp_pcs0_3d + 4)  = zprorca (:,:,:) * zrfact2 * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 5)  = zprorcad(:,:,:) * zrfact2 * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 6)  = zpronew (:,:,:) * zrfact2 * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 7)  = zpronewd(:,:,:) * zrfact2 * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 8)  = zprorcad(:,:,:) * zrfact2 * tmask(:,:,:) * zysopt(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 9)  = zprofed (:,:,:) * zrfact2 * tmask(:,:,:)
 #  if ! defined key_kriest
-      trc3d(:,:,:,jp_pcs0_3d + 10) = zprofen (:,:,:) * zrfact2 * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 10) = zprofen (:,:,:) * zrfact2 * tmask(:,:,:)
 #  endif
 #endif
-
-#if defined key_diatrc && defined key_iomput
-      zrfact2 = 1.e3 * rfact2r
-      IF ( jnt == nrdttrc ) then
-         CALL iom_put( "PPPHY" , zprorca (:,:,:) * zrfact2 * tmask(:,:,:) )  ! primary production by nanophyto
-         CALL iom_put( "PPPHY2", zprorcad(:,:,:) * zrfact2 * tmask(:,:,:) )  ! primary production by diatom
-         CALL iom_put( "PPNEWN", zpronew (:,:,:) * zrfact2 * tmask(:,:,:) )  ! new primary production by nanophyto
-         CALL iom_put( "PPNEWD", zpronewd(:,:,:) * zrfact2 * tmask(:,:,:) )  ! new primary production by diatom
-         CALL iom_put( "PBSi"  , zprorcad(:,:,:) * zrfact2 * tmask(:,:,:) * zysopt(:,:,:) ) ! biogenic silica production
-         CALL iom_put( "PFeD"  , zprofed (:,:,:) * zrfact2 * tmask(:,:,:) )  ! biogenic iron production by diatom
-         CALL iom_put( "PFeN"  , zprofen (:,:,:) * zrfact2 * tmask(:,:,:) )  ! biogenic iron production by nanophyto
+         !
       ENDIF
-#endif
 
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -388,6 +383,6 @@
       !!----------------------------------------------------------------------
 
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampisprod )
+      REWIND( numnatp )                     ! read numnatp
+      READ  ( numnatp, nampisprod )
 
       IF(lwp) THEN                         ! control print
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2819)
@@ -12,15 +12,16 @@
    !!   'key_pisces'                                       PISCES bio-model
    !!----------------------------------------------------------------------
-   !!   p4z_rem       :   Compute remineralization/scavenging of organic compounds
-   !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE sms_pisces      ! 
-   USE prtctl_trc
-   USE p4zint
-   USE p4zopt
-   USE p4zmeso
-   USE p4zprod
-   USE p4zche
+   !!   p4z_rem       :  Compute remineralization/scavenging of organic compounds
+   !!   p4z_rem_init  :  Initialisation of parameters for remineralisation
+   !!   p4z_rem_alloc :  Allocate remineralisation variables
+   !!----------------------------------------------------------------------
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zopt          !  optical model
+   USE p4zche          !  chemical model
+   USE p4zprod         !  Growth rate of the 2 phyto groups
+   USE p4zmeso         !  Sources and sinks of mesozooplankton
+   USE prtctl_trc      !  print control for debugging
 
    IMPLICIT NONE
@@ -61,5 +62,5 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   ztempbac => wrk_2d_1
-      USE wrk_nemo, ONLY:   zdepbac  => wrk_3d_2 , zolimi => wrk_3d_3
+      USE wrk_nemo, ONLY:   zdepbac  => wrk_3d_2, zolimi => wrk_3d_3
       !
       INTEGER, INTENT(in) ::   kt ! ocean time step
@@ -117,8 +118,7 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
+               zstep   = xstep
 # if defined key_degrad
-               zstep = xstep * facvol(ji,jj,jk)
-# else
-               zstep = xstep
+               zstep = zstep * facvol(ji,jj,jk)
 # endif
                ! DOC ammonification. Depends on depth, phytoplankton biomass
@@ -153,8 +153,7 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
+               zstep   = xstep
 # if defined key_degrad
-               zstep = xstep * facvol(ji,jj,jk)
-# else
-               zstep = xstep
+               zstep = zstep * facvol(ji,jj,jk)
 # endif
                !    NH4 nitrification to NO3. Ceased for oxygen concentrations
@@ -214,8 +213,7 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
+               zstep   = xstep
 # if defined key_degrad
-               zstep = xstep * facvol(ji,jj,jk)
-# else
-               zstep = xstep
+               zstep = zstep * facvol(ji,jj,jk)
 # endif
                !    POC disaggregation by turbulence and bacterial activity. 
@@ -266,8 +264,7 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
+               zstep   = xstep
 # if defined key_degrad
-               zstep = xstep * facvol(ji,jj,jk)
-# else
-               zstep = xstep
+               zstep = zstep * facvol(ji,jj,jk)
 # endif
                !     Remineralization rate of BSi depedant on T and saturation
@@ -300,8 +297,7 @@
 !CDIR NOVERRCHK
             DO ji = 1, jpi
+               zstep   = xstep
 # if defined key_degrad
-               zstep = xstep * facvol(ji,jj,jk)
-# else
-               zstep = xstep
+               zstep = zstep * facvol(ji,jj,jk)
 # endif
                !  Compute de different ratios for scavenging of iron
@@ -414,6 +410,6 @@
       !!----------------------------------------------------------------------
 
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampisrem )
+      REWIND( numnatp )                     ! read numnatp
+      READ  ( numnatp, nampisrem )
 
       IF(lwp) THEN                         ! control print
